import bus.Busnetz;
import bus.Haltestelle;
import bus.HaltestellenLinie;
import bus.KeinNachbarException;
import bus.KeineVerbindungException;
import bus.UnbekannteHaltestelleException;

public class UE21Aufgabe1 {

	public static void main(String[] args) {
		int param = 0;
		Busnetz netz = new Busnetz();
		// solange noch zwei weitere Parameter existieren
		while (param + 1 < args.length) {
			try {
				// Verbindungen ermitteln
				Haltestelle von = Haltestelle.getHaltestelle(args[param++]);
				Haltestelle nach = Haltestelle.getHaltestelle(args[param++]);
				HaltestellenLinie[] hsl = netz.getVerbindung(von, nach);

				// Fahrplan ausgeben
				// Strecke
				System.out.println("Strecke " + args[param - 2] + " - "
						+ args[param - 1] + ":");
				// Startpunkt
				System.out.println("Start bei Haltestelle "
						+ hsl[0].getHaltestelle().getName() + " (Linie "
						+ hsl[0].getLinie() + ")");
				int fahrzeit = 0;
				for (int i = 1; i < hsl.length; i++) {
					// evtl. umsteigen
					if (hsl[i - 1].getLinie() != hsl[i].getLinie()) {
						System.out.println("Umsteigen in Linie "
								+ hsl[i].getLinie());
					}
					// Gesamtfahrzeit berechnen
					fahrzeit += hsl[i - 1].getHaltestelle().getFahrzeit(
							hsl[i].getHaltestelle());
					// Haltestelle + Fahrzeit ausgeben
					System.out.println(hsl[i].getHaltestelle().getName() + " "
							+ fahrzeit + " Minuten");
				}
				System.out.println();
			} catch (UnbekannteHaltestelleException exc) {
				System.out.println("Haltestelle " + exc.getName()
						+ " ist unbekannt");
				System.out.println();
			} catch (KeineVerbindungException exc) {
				System.out.println("Keine Verbindung zwischen "
						+ args[param - 2] + " und " + args[param - 1]);
				System.out.println();
			} catch (KeinNachbarException exc) {
				// darf eigentlich nicht vorkommen
				System.out.println("Interner Fehler!");
			}
		}

	}
}
