class NullException extends Exception {
}

class LeeresArrayException extends Exception {
}

class KeineZahlException extends Exception {
}

class NegativerExponentException extends Exception {
}

class UtilL {

	// liefert die kleinste Zahl des uebergebenen Arrays
	public static int minimum(int[] werte) throws NullException,
			LeeresArrayException {
		if (werte == null) {
			throw new NullException();
		}
		if (werte.length == 0) {
			throw new LeeresArrayException();
		}
		int min = werte[0];
		for (int i = 1; i < werte.length; i++) {
			if (werte[i] < min) {
				min = werte[i];
			}
		}
		return min;
	}

	// konvertiert den uebergebenen String in einen int-Wert
	public static int toInt(String str) throws NullException,
			KeineZahlException {
		if (str == null) {
			throw new NullException();
		}
		if (str.length() == 0) {
			throw new KeineZahlException();
		}
		int erg = 0, faktor = 1;
		char ch = str.charAt(0);
		switch (ch) {
		case '-':
			faktor = -1;
			if (str.length() == 1) {
				throw new KeineZahlException();
			}
			break;
		case '+':
			faktor = 1;
			if (str.length() == 1) {
				throw new KeineZahlException();
			}
			break;
		default:
			erg = ch - '0';
			if (erg < 0 || erg > 9) {
				throw new KeineZahlException();
			}
		}
		for (int i = 1; i < str.length(); i++) {
			ch = str.charAt(i);
			int ziffer = ch - '0';
			if (ziffer < 0 || ziffer > 9) {
				throw new KeineZahlException();
			}
			erg = erg * 10 + ziffer;
		}
		return faktor * erg;
	}

	// liefert die Potenz von zahl mit exp, also zahl "hoch" exp
	public static long hoch(long zahl, int exp)
			throws NegativerExponentException {
		if (exp < 0) {
			throw new NegativerExponentException();
		}
		if (exp == 0) {
			return 1L;
		} else {
			return zahl * hoch(zahl, exp - 1);
		}
	}
}

public class UE21Aufgabe17L {
	// Testprogramm
	public static void main(String[] args) {
		try {
			String eingabe = IO.readString("Zahl: ");
			int zahl = UtilL.toInt(eingabe);
			System.out.println(zahl + " hoch " + zahl + " = "
					+ UtilL.hoch(zahl, zahl));
		} catch (NullException exc) {
			// kann nicht vorkommen
		} catch (KeineZahlException exc) {
			System.out.println("Eingabe war keine gueltige Zahl");
		} catch (NegativerExponentException exc) {
			System.out.println("Eingabe war eine negative Zahl");
		}
	}

}
