class StackIsEmptyException extends Exception {
}

class AStack {

	private java.util.ArrayList<Integer> store;

	public AStack() {
		this.store = new java.util.ArrayList<Integer>();
	}

	public final boolean isEmpty() {
		return this.store.isEmpty();
	}

	public final void push(int value) {
		this.store.add(value);
	}

	public final int pop() throws StackIsEmptyException {
		if (this.isEmpty()) {
			throw new StackIsEmptyException();
		}
		return this.store.remove(this.store.size() - 1);
	}
}

class CStack extends AStack {

	public CStack() {
		super();
	}

	@Override
	public boolean equals(Object obj) {
		try {
			if (this == obj) {
				return true;
			}
			if (obj == null) {
				return false;
			}
			if (this.getClass() != obj.getClass()) {
				return false;
			}

			AStack store1 = new AStack();
			int number1 = this.transfer(this, store1);

			CStack other = (CStack) obj;
			AStack store2 = new AStack();
			int number2 = this.transfer(other, store2);

			if (number1 != number2) {
				this.transfer(store1, this);
				this.transfer(store2, other);
				return false;
			}

			boolean result = true;
			while (!store1.isEmpty()) {
				int value1 = store1.pop();
				int value2 = store2.pop();
				result = result && value1 == value2;
				this.push(value1);
				other.push(value2);
			}

			return result;
		} catch (StackIsEmptyException e) {
			// kann nicht sein
			return false;
		}
	}

	private int transfer(AStack from, AStack to) throws StackIsEmptyException {
		int number = 0;
		while (!from.isEmpty()) {
			to.push(from.pop());
			number++;
		}
		return number;
	}

}

public class UE21Aufgabe20 {

	public static void main(String[] args) throws Exception {
		CStack stack1 = new CStack();
		stack1.push(2);
		stack1.push(3);
		stack1.push(4);
		CStack stack2 = new CStack();
		stack2.push(2);
		stack2.push(3);
		stack2.push(4);
		System.out.print(stack1.equals(stack2));
		stack2.pop();
		System.out.print(stack1.equals(stack2));
	}
}

