class UnbekannterNutzerException extends Exception {
}

class KeineAusgeliehenenFilmeException extends Exception {

	public KeineAusgeliehenenFilmeException(Nutzer nutzer) {
	}

	// liefert den Nutzer, der aktuell keine Filme ausgeliehen hat
	public Nutzer getNutzer() {
		return null;
	}
}

// Die Klasse Nutzer repraesentiert einen Videotheksnutzer; Nutzer haben
// jeweils genau einen Namen und eine Benutzungsnummer
class Nutzer {

	// liefert das dem uebergebenen Namen zugeordnete Nutzer-Objekt
	// wirft eine Exception, wenn zu dem Namen kein angemeldeter Nutzer
	// existiert
	public static Nutzer getNutzer(String name)
			throws UnbekannterNutzerException {
		return null;
	}

	// liefert den Namen des Nutzers
	public String getName() {
		return null;
	}

	// liefert die Benutzungsnummer des Nutzers
	public int getBenutzungsnummer() {
		return 0;
	}
}

// Die Klasse Video repraesentiert ein Videoexemplar der Videothek; Videos haben
// jeweils genau einen Regisseur und einen Titel
class Video {

	// liefert den Regisseurnamen
	public String getRegisseur() {
		return null;
	}

	// liefert den Titel des Videos
	public String getTitel() {
		return null;
	}
}

// Die Klasse AusgeliehenesVideo repraesentiert ein ausgeliehenes Video; Objekte
// der Klasse speichern das ausgeliehene Video, den Nutzer, der das Video
// ausgeliehen hat, und die angefallenen Ausleihkosten
class AusgeliehenesVideo {

	// liefert das ausgeliehene Video
	public Video getVideo() {
		return null;
	}

	// liefert den Nutzer, der das Video ausgeliehen hat
	public Nutzer getNutzer() {
		return null;
	}

	// liefert die aktuell angefallenen Ausleihkosten (in vollen EUR)
	// fuer das ausgeliehene Video
	public int getKosten() {
		return 0;
	}
}

// Die Klasse Videothek repraesentiert eine Videothek
class Videothek {
	public Videothek() {
		// liest alle benoetigten Daten bspw. aus einer Datenbank ein
	}

	// liefert alle aktuell ausgeliehenen Videos des angegebenen Nutzers
	public AusgeliehenesVideo[] getAusgelieheneVideos(Nutzer nutzer)
			throws KeineAusgeliehenenFilmeException {
		return null;
	}
}

public class UE21Aufgabe21 {

	public static void main(String[] args) {
		int param = 0;
		Videothek videothek = new Videothek();
		// so lange noch Parameter existieren
		while (param < args.length) {
			try {
				Nutzer nutzer = Nutzer.getNutzer(args[param]);
				AusgeliehenesVideo[] ausgelieheneVideos = videothek
						.getAusgelieheneVideos(nutzer);

				System.out.println(args[param] + " hat aktuell "
						+ ausgelieheneVideos.length + "Videos ausgeliehen: ");
				int gesamtkosten = 0;
				for (int i = 0; i < ausgelieheneVideos.length; i++) {
					System.out.println(ausgelieheneVideos[i].getVideo()
							.getRegisseur()
							+ ":"
							+ ausgelieheneVideos[i].getVideo().getTitel());
					gesamtkosten += ausgelieheneVideos[i].getKosten();
				}

				System.out.println("Angefallene Ausleihekosten = "
						+ gesamtkosten + "EUR.");
			} catch (UnbekannterNutzerException exc) {
				System.out.println("Ein Nutzer mit dem Namen " + args[param]
						+ " ist unbekannt.");
			} catch (KeineAusgeliehenenFilmeException exc) {
				System.out.println("Nutzer " + args[param]
						+ "(Benutzungsnummer "
						+ exc.getNutzer().getBenutzungsnummer()
						+ ") hat aktuell keine Videos ausgeliehen.");
			}
			System.out.println();
			param++;
		}
	}
}