class FullException extends Exception {
}

class EmptyException extends Exception {
}

class Stack {

	protected int[] store; // zum Speichern von Daten
	protected int current; // aktueller Index

	public Stack(int size) {
		this.store = new int[size];
		this.current = -1;
	}

	public boolean isFull() {
		return this.current == this.store.length - 1;
	}

	public boolean isEmpty() {
		return this.current == -1;
	}

	public void push(int value) throws FullException {
		if (!this.isFull()) {
			this.store[++this.current] = value;
		} else {
			throw new FullException();
		}
	}

	public int pop() throws EmptyException {
		if (!this.isEmpty()) {
			return this.store[this.current--];
		} else {
			throw new EmptyException();
		}
	}
}

class UniqueStack extends Stack {

	public UniqueStack(int size) {
		super(size);
	}

	public UniqueStack(UniqueStack stack) {
		super(stack.store.length);
		for (int i = 0; i < stack.store.length; i++) {
			this.store[i] = stack.store[i];
		}
		this.current = stack.current;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null || this.getClass() != obj.getClass()) {
			return false;
		}

		UniqueStack other = (UniqueStack) obj;

		if (this.current != other.current) { //
			return false;
		}
		for (int i = 0; i <= this.current; i++) {
			if (this.store[i] != other.store[i]) {
				return false;
			}
		}
		return true;
	}

	@Override
	public void push(int value) throws FullException {
		for (int i = 0; i <= this.current; i++) {
			if (this.store[i] == value) {
				return;
			}
		}
		super.push(value);
	}
}

public class UE21Aufgabe23 {

	// Testprogramm 
	public static void main(String[] args) throws Exception {
		UniqueStack stack = new UniqueStack(10);
		stack.push(4);
		stack.push(7);
		stack.push(4);
		stack.push(1);
		stack.push(1);
		stack.push(4);
		while (!stack.isEmpty()) {
			System.out.println(stack.pop());
		}
	}

}
