// eigentlich public
class StrichZahl {

	public static int OVERFLOW = 1000;

	protected int wert; // [0..OVERFLOW-1]

	public StrichZahl() {
		this.wert = 0;
	}

	public StrichZahl(int w) throws NumberFormatException {
		// Parameter ueberpuefen
		if (w < 0) {
			throw new NumberFormatException();
		}
		this.wert = w % OVERFLOW;
	}

	// Vor.: valueStr != null
	public StrichZahl(String wertStr) throws NumberFormatException {
		for (int i = 0; i < wertStr.length(); i++) {
			char ch = wertStr.charAt(i);
			if (ch == '|') {
				this.wert++;
			} else if (ch != ' ') {
				throw new NumberFormatException(wertStr);
			}
		}
		this.wert = this.wert % OVERFLOW;
	}

	// Vor.: obj != null
	public StrichZahl(StrichZahl obj) {
		this.wert = obj.wert;
	}

	@Override
	public StrichZahl clone() {
		return new StrichZahl(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (this.getClass() != obj.getClass()) {
			return false;
		}
		return this.wert == ((StrichZahl) obj).wert;
	}

	@Override
	public String toString() {
		String erg = "";
		for (int i = 1; i <= this.wert; i++) {
			erg += "|";
			if (i % 5 == 0 && i != this.wert) {
				erg += " ";
			}
		}
		return erg;
	}

	// Vor.: obj != null
	public StrichZahl add(StrichZahl obj) {
		this.wert = (this.wert + obj.wert) % OVERFLOW;
		return this;
	}

	// Vor.: obj1 != null && obj2 != null
	public static StrichZahl add(StrichZahl obj1, StrichZahl obj2) {
		StrichZahl erg = new StrichZahl(obj1);
		erg.add(obj2);
		return erg;
	}

}

public class UE21Aufgabe25 {

	// Testprogramm
	public static void main(String[] args) {
		StrichZahl z1 = new StrichZahl(7);
		StrichZahl z2 = new StrichZahl("||||||||");
		System.out.println(z1.toString());
		System.out.println(z2.toString());
		z1.add(z2);
		System.out.println(z1.toString());
		System.out.println(StrichZahl.add(z1, z2).toString());
	}

}
