// eigentlich public
class StrichZahl2 {

	public static int OVERFLOW = 1000;

	protected String wert;

	public StrichZahl2() {
		this.wert = "";
	}

	public StrichZahl2(int w) throws NumberFormatException {
		// Parameter ueberpuefen
		if (w < 0) {
			throw new NumberFormatException();
		}
		this.wert = "";
		for (int i = 1; i <= w % OVERFLOW; i++) {
			this.wert += "|";
		}
	}

	// Vor.: valueStr != null
	public StrichZahl2(String wertStr) throws NumberFormatException {
		int w = 0;
		for (int i = 0; i < wertStr.length(); i++) {
			char ch = wertStr.charAt(i);
			if (ch == '|') {
				w++;
			} else if (ch != ' ') {
				throw new NumberFormatException(wertStr);
			}
		}
		this.wert = "";
		for (int i = 1; i <= w % OVERFLOW; i++) {
			this.wert += "|";
		}
	}

	// Vor.: obj != null
	public StrichZahl2(StrichZahl2 obj) {
		this.wert = new String(obj.wert);
	}

	@Override
	public StrichZahl2 clone() {
		return new StrichZahl2(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (this.getClass() != obj.getClass()) {
			return false;
		}
		return this.wert.equals(((StrichZahl2) obj).wert);
	}

	@Override
	public String toString() {
		String erg = "";
		for (int i = 1; i <= this.wert.length(); i++) {
			erg += "|";
			if (i % 5 == 0 && i != this.wert.length()) {
				erg += " ";
			}
		}
		return erg;
	}

	// Vor.: obj != null
	public StrichZahl2 add(StrichZahl2 obj) {
		this.wert += obj.wert;
		korrigiereOverflow();
		return this;
	}

	// Vor.: obj1 != null && obj2 != null
	public static StrichZahl2 add(StrichZahl2 obj1, StrichZahl2 obj2) {
		StrichZahl2 erg = new StrichZahl2(obj1);
		erg.add(obj2);
		return erg;
	}

	private void korrigiereOverflow() {
		if (this.wert.length() >= OVERFLOW) {
			this.wert = "";
			for (int i = 1; i <= this.wert.length() % OVERFLOW; i++) {
				this.wert += "|";
			}
		}
	}

}

public class UE21Aufgabe25b {

	// Testprogramm
	public static void main(String[] args) {
		StrichZahl2 z1 = new StrichZahl2(2007);
		StrichZahl2 z2 = new StrichZahl2("||| | ||||");
		System.out.println(z1);
		System.out.println(z2);
		System.out.println(z1.add(z2));
		System.out.println(StrichZahl2.add(z1, z2));
	}

}
