// korrekt: alle Klassen public und in eigene Dateien
class KeineNummerException extends Exception {
}

class UngueltigeTasteException extends Exception {
}

class UnbelegteTasteException extends Exception {
}

class Telefon {

	private String letzteNummer;
	private String[] speichertasten;

	// Voraussetzung: anzahlSpeichertasten >= 0 (weitere Exception auch ok)
	public Telefon(int anzahlSpeichertasten) {
		this.letzteNummer = null;
		this.speichertasten = new String[anzahlSpeichertasten];
		for (int i = 0; i < this.speichertasten.length; i++) {
			this.speichertasten[i] = null;
		}
	}

	// Voraussetzung: telefon != null! (weitere Exception auch ok)
	public Telefon(Telefon telefon) {
		this.letzteNummer = telefon.letzteNummer;
		this.speichertasten = new String[telefon.speichertasten.length];
		for (int i = 0; i < this.speichertasten.length; i++) {
			this.speichertasten[i] = new String(telefon.speichertasten[i]);
		}
	}

	// Voraussetzung: nummer != null und gueltige Zeichen (weitere Exception auch ok)
	public void waehlen(String nummer) {
		System.out.println(nummer);
		this.letzteNummer = nummer;
	}

	public String getLetzteNummer() throws KeineNummerException {
		// Exception nicht unbedingt notwendig
		if (this.letzteNummer == null) {
			throw new KeineNummerException();
		}
		return this.letzteNummer;
	}

	public void letzteNummerSpeichern(int taste) throws KeineNummerException,
			UngueltigeTasteException {
		if (this.letzteNummer == null) {
			throw new KeineNummerException();
		}
		if (taste < 0 || taste >= this.speichertasten.length) {
			throw new UngueltigeTasteException();
		}
		this.speichertasten[taste] = this.letzteNummer;

	}

	public void waehlen(int taste) throws UngueltigeTasteException,
			UnbelegteTasteException {
		if (taste < 0 || taste >= this.speichertasten.length) {
			throw new UngueltigeTasteException();
		}
		if (this.speichertasten[taste] == null) {
			throw new UnbelegteTasteException();
		}
		this.waehlen(this.speichertasten[taste]);
	}
}
