class KeineWerteExc extends Exception {
}

class KeinPosPendantExc extends Exception {
}

class AusserhalbWertebereichExc extends Exception {
}

class MatheMit {

	static double mittelwert(double[] werte) throws KeineWerteExc {
		if (werte == null || werte.length == 0) {
			throw new KeineWerteExc();
		}
		double erg = werte[0];
		for (int i = 1; i < werte.length; i++) {
			erg += werte[i];
		}
		return erg / werte.length;
	}

	static int betrag(double wert) throws KeinPosPendantExc, AusserhalbWertebereichExc {
		if (wert == Integer.MIN_VALUE) {
			throw new KeinPosPendantExc();
		}
		if (wert < Integer.MIN_VALUE || wert > Integer.MAX_VALUE) {
			throw new AusserhalbWertebereichExc();
		}
		int intWert = (int) wert;
		return intWert < 0 ? -intWert : intWert;
	}
}

public class UE21Aufgabe36 {

	static void printBerechnungen(double[][] werte) {
		for (int r = 0; r < werte.length; r++) {
			try {
				System.out.println("Messreihe " + (r + 1) + ": ");
				System.out.println("Ergebnis = " + MatheMit.betrag(MatheMit.mittelwert(werte[r])));
			} catch (KeineWerteExc exc) {
				System.out.println("Fehler: keine Werte in Messreihe " + (r + 1));
			} catch (AusserhalbWertebereichExc exc) {
				System.out.println("Fehler: Ergebnis zu klein oder zu gross");
			} catch (KeinPosPendantExc exc) {
				System.out.println("Ergebnis ist 2.147.483.648");
			}
		}
	}

	public static void main(String[] args) {
		double[][] werte = { { 2, 8, 5 }, null, { -2147483649.0, -2147483647.0 }, { -12147483649.0, -12147483647.0 },
				{ -4, -8 } };
		printBerechnungen(werte);
	}

}
