package automat;

public class Automat {

	private int geldStand;
	private int km;

	public Automat() {
		this.geldStand = 0;
		this.km = 0;
	}

	public Automat(Automat obj) {
		this.geldStand = obj.geldStand;
		this.km = obj.km;
	}

	protected Automat clone() {
		return new Automat(this);
	}

	public boolean equals(Object obj) {
		Automat automat = (Automat) obj;
		return this.geldStand == automat.geldStand && this.km == automat.km;
	}

	public String toString() {
		return "Ausgewhlte Kilometer = " + this.km + "; Geldstand = "
				+ this.geldStand;
	}

	public void kmAuswahl(int km) {
		this.km = km;
	}

	public void geldEinwerfen(int euro) {
		this.geldStand += euro;
	}

	public Ticket getTicket() throws UngueltigeKMException,
			NichtGenugGeldException {
		if (this.km <= 0) {
			throw new UngueltigeKMException();
		}
		if (this.geldStand < this.km) {
			throw new NichtGenugGeldException();
		}
		this.geldStand -= this.km;
		return new Ticket(this.km);
	}
}
